%define name	bincimap
%define version	1.2.9
%define release	2mdk

Summary:	Binc IMAP server
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
URL:		http://www.bincimap.org/
Source0:	%{name}-%{version}final.tar.bz2
Source1:	bincimap.cnf.bz2
Source2:	mkimapdcert.bz2
Source3:	multichkpwds-1.0.tar.bz2
Patch0:		bincimap-1.2.0-misc_fixes_to_finally_make_it_work_out_of_the_box.patch.bz2
Patch1:		bincimap-1.2.9final-gcc4.diff.bz2
BuildPreReq:	autoconf2.5
BuildPreReq:	bison
BuildPreReq:	flex
BuildPreReq:	libgcc1
BuildPreReq:	libstdc++-devel
BuildPreReq:	libtool
BuildPreReq:	openssl-devel
BuildPreReq:	zlib-devel
PreReq:		checkpassword-pam
PreReq:		rpm-helper
PreReq:		xinetd
Requires:	openssl
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Binc IMAP is an IMAP server, written in C++ for the Linux platform. It
supports Dan J. Bernstein's Maildir format and checkpassword
authentication.

As an alternative to existing similar IMAP servers, Binc IMAP strives
to be

* very easy to install and use, but robust, stable and secure
* absolutely compliant with the IMAP4rev1 protocol
* simple and modular in design, making it very easy for
  third parties to utilize the source code and enhance the
  product.

%prep

%setup -q -n %{name}-%{version}final -a3
%patch0 -p1 -b .misc_fixes_to_finally_make_it_work_out_of_the_box
%patch1 -p0 -b .gcc4

%build

%configure2_5x \
    --prefix=%{_prefix} \
    --exec-prefix=%{_sbindir} \
    --bindir=%{_sbindir} \
    --sbindir=%{_sbindir} \
    --sysconfdir=%{_sysconfdir} \
    --localstatedir=%{_localstatedir}/bincimap-chroot

%make

# make multichkpwds
gcc %{optflags} -o multichkpwds multichkpwds-1.0/multichkpwds.c

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/ssl/bincimap
install -d %{buildroot}%{_sysconfdir}/xinetd.d
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man{1,5}
install -d %{buildroot}%{_localstatedir}/bincimap-chroot

install -m755 src/bincimapd %{buildroot}%{_sbindir}/
install -m755 src/bincimap-up %{buildroot}%{_sbindir}/
install -m755 multichkpwds %{buildroot}%{_bindir}/

install -m644 conf/bincimap.conf %{buildroot}%{_sysconfdir}/bincimap.conf
install -m644 conf/xinetd-bincimap %{buildroot}%{_sysconfdir}/xinetd.d/bincimap
install -m644 conf/xinetd-bincimaps %{buildroot}%{_sysconfdir}/xinetd.d/bincimaps

install -m644 man/bincimapd.1 %{buildroot}%{_mandir}/man1/
install -m644 man/bincimap-up.1 %{buildroot}%{_mandir}/man1/
install -m644 man/bincimap.conf.5 %{buildroot}%{_mandir}/man5/

bzcat %{SOURCE1} > %{buildroot}%{_sysconfdir}/ssl/bincimap/bincimap.cnf
bzcat %{SOURCE2} > mkimapdcert

chmod 644 %{buildroot}%{_sysconfdir}/ssl/bincimap/bincimap.cnf

# fix the DJB scripts directory
find service -type f -name "Makefile*" | xargs rm -f
find service -type f -name "down" | xargs rm -f
find service -type f -name "*.in" | xargs rm -f

%pre
%_pre_useradd bincimap %{_localstatedir}/bincimap-chroot /bin/false

%postun
%_postun_userdel bincimap

%post
if [ $1 = "1" ]; then 
  #Create a self-signed server key and certificate 
  #The script checks first if they exists, if yes, it exits, 
  #otherwise, it creates them.
  if ! [ -f %{_sysconfdir}/ssl/bincimap/bincimap.pem ];then
    sh %{_docdir}/%{name}-%{version}/mkimapdcert >/dev/null 
  fi
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%files
%defattr(-, root, root)
%doc service mkimapdcert AUTHORS ChangeLog README TODO doc/bincimap* doc/*.txt
%doc multichkpwds-1.0/multichkpwds.README
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/bincimap.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/bincimap
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/bincimaps
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ssl/bincimap/bincimap.cnf
%attr(0755,root,root) %{_bindir}/multichkpwds
%attr(0755,root,root) %{_sbindir}/bincimap-up
%attr(0755,root,root) %{_sbindir}/bincimapd
%attr(0644,root,root) %{_mandir}/man1/bincimapd.1*
%attr(0644,root,root) %{_mandir}/man1/bincimap-up.1*
%attr(0644,root,root) %{_mandir}/man5/bincimap.conf.5*
%dir %attr(0755,bincimap,bincimap) %{_localstatedir}/bincimap-chroot

%changelog
* Fri Aug 26 2005 Oden Eriksson <oeriksson@mandriva.com> 1.2.9-2mdk
- added one gcc4 patch

* Thu Jul 22 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.9-1mdk
- 1.2.9

* Thu Jun 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.8-1mdk
- 1.2.8

* Mon Jun 07 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.2.7-2mdk 
- rebuilt with gcc v3.4.x

* Mon Apr 19 2004 Michael Scherer <misc@mandrake.org> 1.2.7-1mdk 

* Sat Sep 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.3-1mdk
- 1.2.3
- drop patches included in the upstream source

* Sun Sep 14 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.2-2mdk
- added P1 & P2 by the author

* Thu Sep 11 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.2-1mdk
- 1.2.2
- fix explicit-lib-dependency

* Tue Sep 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.1-1mdk
- 1.2.1

* Fri Aug 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.0-1mdk
- 1.2.0
- fixed P0

* Mon Aug 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.0-0.2mdk
- added %%{_bindir}/multichkpwds

* Sun Aug 17 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.2.0-0.1mdk
- 1.2.0b1

* Thu Aug 14 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.9-1mdk
- 1.1.9

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.8-2mdk
- rebuild

* Mon May 26 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.8-1mdk
- 1.1.8

* Wed May 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.7-1mdk
- 1.1.7
- use the %%configure2_5x macro
- misc spec file fixes

* Mon May 19 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.6-1mdk
- 1.1.6

* Fri Apr 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.5-3mdk
- fix buildrequires, thanks to Stefan van der Eijks robot

* Thu Apr 24 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.5-2mdk
- really make it work out of the box this time...

* Wed Apr 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.5-1mdk
- added P0 to actually try to make it work out of the box..., he he he...
- stole some %%post logic from the apache2 spec file for the cert generation
- many spec file fixes

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.4-1mdk
- 1.1.4

* Wed Apr 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.3-1mdk
- 1.1.3

* Sat Mar 29 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.2-1mdk
- 1.1.2
- dropped P0, it's included upstream

* Wed Mar 26 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.1-1mdk
- 1.1.1
- added P0

* Tue Mar 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.1.0-1mdk
- 1.1.0
- new url
- misc spec file fixes

* Thu Mar 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.25-1mdk
- 1.0.25

* Sat Feb 22 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.24-1mdk
- 1.0.24

* Mon Feb 17 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.23-1mdk
- 1.0.23(-2)
- remove PreReq: Maildir & maildirmake++
- misc spec file fixes

* Sun Feb 09 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.22-1mdk
- 1.0.22

* Sun Feb 09 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.21-1mdk
- 1.0.21
- pcre not needed anymore
- drop useless P0
- now there's a ChangeLog!
- fix %%post, thanks to Buchan Milne

* Thu Feb 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.20-2mdk
- require Maildir & maildirmake++

* Wed Feb 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.20-1mdk
- 1.0.20
- now there's a readme!

* Tue Feb 04 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.19-1mdk
- 1.0.19
- rediff P0
- misc spec file fixes

* Mon Feb 03 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.18-1mdk
- 1.0.18
- added the bincimap.spec in %%doc because it's where the changelog is
- move binaries to %%{_sbindir}
- misc spec file fixes

* Mon Jan 27 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.17-1mdk
- initial cooker contrib
- use P0 until it is configurable
- added modified S1 & S2 from courier-imap
